DECLARE FUNCTION MenuResize% ()
DECLARE FUNCTION FileSelect$ (extension$, default$, p$)
DECLARE SUB MenuOverview ()
DECLARE SUB MenuStatistics ()
DECLARE SUB ShowHelp ()
DECLARE SUB Statistics3 ()
DECLARE SUB Statistics2 ()
DECLARE SUB Statistics1 ()
DECLARE FUNCTION MenuSave% (f$)
DECLARE FUNCTION MenuOpen% ()
DECLARE SUB SelectSprite (SelS1%)
DECLARE SUB ShowAbout ()
DECLARE SUB Quit ()
DECLARE FUNCTION GetTile% (x%, y%)
DECLARE SUB SelectTile (SelT%)
DECLARE FUNCTION CheckForSave% ()
DECLARE FUNCTION MenuNew% ()
DECLARE SUB DrawTruncPic (x%, y%, dat$, t%, h%)
DECLARE SUB SetTile (x%, y%, t%)
DECLARE SUB ShowLevel (xp%, yp%, nc%, nr%, grid%)
DECLARE SUB DrawCursor (x%, y%, s%)
DECLARE SUB Scroll (d%, n%)
DECLARE SUB MainEditor ()
DECLARE SUB LoadTilesAndSprites ()
DECLARE SUB CreateLevel ()
DECLARE FUNCTION ListSelect% (x%, y%, n%, d%)
DECLARE SUB Message (s AS STRING)
DECLARE FUNCTION Prompt$ (s AS STRING)
DECLARE SUB SetFontBuf (NewBuf$)
DECLARE SUB MainMenu ()
DECLARE FUNCTION FontInput$ (text$, length%, xp%, yp%)
DECLARE FUNCTION SelectLevelSize% (ow%, oh%)
DECLARE FUNCTION Tile$ (i AS INTEGER)
DECLARE SUB ClearScreen ()
DECLARE SUB DrawPic (x%, y%, dat$, t%)
DECLARE SUB LoadTiles ()
DECLARE SUB SelectTileSet ()
DECLARE SUB FontBox (x%, y%, w%, h%)
DECLARE SUB FontPrint (s AS STRING, x AS INTEGER, y AS INTEGER)
DECLARE SUB LoadFont ()
DECLARE SUB DrawTile (x%, y%, i%)
DECLARE FUNCTION LoadLevel% (FileName$)
DECLARE SUB GetTileColors ()
DECLARE SUB xLine (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, t AS INTEGER)
DECLARE SUB xFill (x%, y%, t%)
DECLARE SUB xRect (x1%, y1%, x2%, y2%, t%)
DECLARE SUB xFillLine (x%, y%, t%)
DECLARE SUB ShowSprites (xp%, yp%)
DECLARE SUB SaveLevel (FileName$)
DECLARE SUB LoadSprites ()
DECLARE SUB SetColor (i AS INTEGER, R AS INTEGER, G AS INTEGER, b AS INTEGER)
DECLARE SUB CompressData (IData() AS INTEGER, w AS INTEGER, h AS INTEGER, filen AS INTEGER)

'Functions in FILEFUNC.BAS
DECLARE FUNCTION Fixpath$ (path$)
DECLARE FUNCTION ExtractPath$ (n$)
DECLARE FUNCTION ExtractName$ (n$)
DECLARE FUNCTION GetCurPath$ ()
DECLARE SUB ChDrive (drive$)
DECLARE FUNCTION Dir$ (filespec$, attrib AS INTEGER)
DECLARE FUNCTION ValidDrive% (d$)
DECLARE FUNCTION SplitString% (s$, sep$, array$(), max%)
DECLARE SUB QuickSort (sortarray$(), Lower%, Upper%)


DEFINT A-Z
'$INCLUDE: 'QB.BI'
'$INCLUDE: 'graphics.inc'

'Rearrange the stack so we don't get overflows when doing fills
CLEAR , , 3000
'$DYNAMIC

DIM SHARED LevelW AS INTEGER, LevelH AS INTEGER 'Level size
DIM SHARED LevelX AS INTEGER, LevelY AS INTEGER 'Level view position
DIM SHARED LevelData(24 * 17) AS INTEGER 'The main level data
DIM SHARED ExtraData(24 * 17) AS INTEGER 'The extra level data
DIM SHARED LvlFile$ 'The name of the current level
CONST MAXWIDTH = 170
CONST MAXHEIGHT = 170

DIM SHARED TileSet AS INTEGER
DIM SHARED NumTiles AS LONG
DIM SHARED NumSprites AS LONG

DIM SHARED Tile1(0 TO 319) AS STRING * 258 'Tiles -- parts 1 and 2 :)
DIM SHARED Tile2(320 TO 689) AS STRING * 258 'QB won't let me have an array 160000 bytes :(
DIM SHARED Sprite(17) AS STRING '18 sprites is max
DIM SHARED KeenSprite AS STRING
DIM SHARED LogoSprite AS STRING
DIM SHARED TileColors(640) AS INTEGER  'Only 624 Tiles max in episode 3
DIM SHARED CursorMode AS INTEGER

DIM SHARED OrigPath$

DIM SHARED Font(127) AS STRING * 66
DIM SHARED FontBuf AS STRING * 1000

DIM SHARED Editing AS INTEGER
DIM SHARED Saved AS INTEGER
DIM SHARED MapFile AS INTEGER

DIM SHARED ShowGrid AS INTEGER
DIM SHARED CursorX AS INTEGER
DIM SHARED CursorY AS INTEGER
DIM SHARED StartX AS INTEGER
DIM SHARED StartY AS INTEGER
DIM SHARED SelTile AS INTEGER
DIM SHARED SelTileZ AS INTEGER
DIM SHARED SelTileX AS INTEGER
DIM SHARED SelTileC AS INTEGER
DIM SHARED SelSprite AS INTEGER

DIM SHARED DrawCursorBuf((16 * 16) \ 2 + 2) AS INTEGER 'buffer for DrawCursor
DIM SHARED FillTile AS INTEGER     'The current fill Tile

ON ERROR GOTO DefError

OrigPath$ = GetCurPath$
IF RIGHT$(OrigPath$, 1) <> "\" THEN OrigPath$ = OrigPath$ + "\"

LoadFont

SCREEN 13
SetColor 255, 255, 255, 255

ClearScreen

Saved = 1
StartX = -1
StartY = -1

IF COMMAND$ <> "" THEN
	IF LoadLevel(COMMAND$) THEN
		t = ASC(RIGHT$(COMMAND$, 1)) - 49
		IF t >= 0 AND t <= 2 THEN
			TileSet = t
			LoadTilesAndSprites
		ELSE
			TileSet = 0
			LevelW = 20
			LevelH = 13
			LoadTilesAndSprites
			MainMenu
		END IF
	ELSE
		TileSet = 0
		LevelW = 20
		LevelH = 13
		LoadTilesAndSprites
		MainMenu
	END IF
ELSE
	TileSet = 0
	LevelW = 20
	LevelH = 13
	LoadTilesAndSprites
	MainMenu
END IF

MainEditor

Quit

'        CASE "o"
'            LINE (0, 0)-(319, 159), 35, BF
'            FOR y = 0 TO LevelH - 1
'                FOR x = 0 TO LevelW - 1
'                    PSET (x, y), TileColors(LevelData(y * LevelW + x))
'                NEXT
'            NEXT
'            WHILE INKEY$ = "": WEND
'            ShowLevel lx, ly, -1, -1, ShowGrid

DefError:
RESUME NEXT

'Error in CreateLevel/LoadLevel (i.e. level too big)
CLError:
	IF ERR = 6 THEN 'Overflow
		t$ = Prompt("Too big! Defaulting to 20x13")
		LevelW = 24 'border of 4, remember :)
		LevelH = 17
		RESUME
	ELSE
		RESUME NEXT
	END IF

REM $STATIC
FUNCTION CheckForSave
	OldBuf$ = FontBuf$
	CheckForSave = 1
	IF Saved = 0 THEN
		a$ = LCASE$(Prompt$("Level not saved! Save (Y/N)?"))
		IF a$ = "y" THEN
			SaveLevel LvlFile$
		ELSEIF a$ = CHR$(27) THEN
			CheckForSave = 0
		END IF
	END IF
	SetFontBuf OldBuf$
END FUNCTION

SUB ClearScreen
	LINE (0, 0)-(319, 199), 15, BF
	FontBuf$ = STRING$(1000, 32)
END SUB

SUB CompressData (IData() AS INTEGER, w AS INTEGER, h AS INTEGER, filen AS INTEGER)
	DIM k AS STRING * 2
	k = CHR$(&HFE) + CHR$(&HFE)
	
	last = -1
	lastn = 0
	FOR y = 0 TO h - 1
		FOR x = 0 TO w - 1
			b = IData(y * w + x)
			IF lastn > 0 THEN
				IF b <> last THEN
					IF lastn >= 4 THEN
						PUT #filen, , k
						PUT #filen, , lastn
						PUT #filen, , last
						last = b
						lastn = 1
					ELSE
						FOR i = 1 TO lastn
							PUT #filen, , last
						NEXT
						last = b
						lastn = 1
					END IF
					lastn = 1
					last = b
				ELSE
					lastn = lastn + 1
				END IF
			ELSE
				last = b
				lastn = 1
			END IF
		NEXT
	NEXT
	IF lastn > 0 THEN
		IF lastn >= 4 THEN
			PUT #filen, , k
			PUT #filen, , lastn
			PUT #filen, , last
		ELSE
			FOR i = 1 TO lastn
				PUT #filen, , last
			NEXT
		END IF
		lastn = 1
		last = b
	END IF
END SUB

SUB CreateLevel
	ON ERROR GOTO CLError
	LevelName$ = ""
   
	REDIM LevelData(LevelW * LevelH) AS INTEGER
	REDIM ExtraData(LevelW * LevelH) AS INTEGER

	FOR y = 0 TO LevelH - 1
		FOR x = 0 TO LevelW - 1
			IF (x < 2 OR x >= LevelW - 2) OR (y < 2 OR y >= LevelH - 2) THEN
				IF TileSet = 2 THEN
					LevelData(y * LevelW + x) = 245
				ELSE
					LevelData(y * LevelW + x) = 144
				END IF
			ELSE
				LevelData(y * LevelW + x) = 143
			END IF
			ExtraData(y * LevelW + x) = 0
		NEXT
	NEXT
	Saved = 0

	ON ERROR GOTO DefError
END SUB

SUB DrawCursor (x, y, s)
	STATIC show
	IF s = -1 THEN
		IF show = 0 THEN
			show = 1
		ELSE
			show = 0
		END IF
	ELSE
		show = s
	END IF
	IF show = 1 THEN
		GET (x, y)-(x + 15, y + 15), DrawCursorBuf
		PSET (x, y), 7
		PSET (x + 15, y + 15), 7
		PSET (x, y + 15), 7
		PSET (x + 15, y), 7
		IF CursorMode = 1 THEN
			DrawPic x + 4, y + 4, Font(ASC("R")), 15
		ELSEIF CursorMode = 2 THEN
			DrawPic x + 4, y + 4, Font(ASC("L")), 15
		ELSE
			DrawPic x + 4, y + 4, Font(9), 15
		END IF
		'LINE (x , y )-(x  + 15, y  + 15), 15, B
	ELSE
		PUT (x, y), DrawCursorBuf, PSET
	END IF
END SUB

SUB DrawPic (x, y, dat$, t)
	IF t = -1 THEN
		PutBlock x, y, ASC(MID$(dat$, 1, 1)), ASC(MID$(dat$, 2, 1)), VARSEG(dat$), SADD(dat$) + 2, 0
	ELSE
		PutSprite x, y, ASC(MID$(dat$, 1, 1)), ASC(MID$(dat$, 2, 1)), VARSEG(dat$), SADD(dat$) + 2, 0
	END IF
END SUB

SUB DrawTile (x, y, i)
	IF i < 320 THEN
		DrawPic x, y, Tile1(i), -1
	ELSEIF i < NumTiles THEN
		DrawPic x, y, Tile2(i), -1
	ELSE
		LINE (x * 16, y * 16)-(x * 16 + 15, y * 16 + 15), 12, BF
	END IF
END SUB

SUB DrawTruncPic (x, y, dat$, t, h)
	IF t = -1 THEN
		PutBlock x, y, ASC(MID$(dat$, 1, 1)), h, VARSEG(dat$), SADD(dat$) + 2, 0
	ELSE
		PutSprite x, y, ASC(MID$(dat$, 1, 1)), h, VARSEG(dat$), SADD(dat$) + 2, 0
	END IF
END SUB

FUNCTION FileSelect$ (extension$, default$, p$)
	'Get [directories] and files, sort the list
	'"  [Filename]"
	'Display them in 20 rows of 3

	'DRIVE:\PATH\DIRECTORY
	'
	'  [Filename]  [Filename]  [Filename]
	'  [Filename]  [Filename]  [Filename]
	'...
	'  [Filename]  [Filename]  [Filename]
	'  [Filename]  [Filename]  [Filename]
	'Open File: ________

	DIM names(540) AS STRING
	DIM i AS INTEGER, nfiles AS INTEGER, ndirs AS INTEGER, nnames AS INTEGER
   
	DIM sel AS INTEGER, FileName AS STRING
	DIM ly AS INTEGER, li AS INTEGER

	OldBuf$ = FontBuf$

	FontBox 4, 0, 32, 25

	FileName$ = CHR$(0)

	DO
 
		'Fill the list of dirs and files
		IF LEN(GetCurPath$) <= 3 THEN
			notroot = 0
			i = 0
		ELSE
			notroot = 1
			names(0) = ".."
			i = 1
		END IF
	
		'Add directories to the list
		f$ = UCASE$(Dir$("*.*", 16))
		DO WHILE f$ <> ""
			names(i) = f$
			i = i + 1
			IF i = 50 THEN EXIT DO    'no more than 50 directories
			f$ = UCASE$(Dir$("", 16))
		LOOP
		ndirs = i

		f$ = LCASE$(Dir$("*." + extension$, 0))
		DO WHILE f$ <> ""
			names(i) = LEFT$(f$, LEN(f$) - 4)
			i = i + 1
			IF i = 512 THEN EXIT DO
			f$ = LCASE$(Dir$("", 0))
		LOOP
		nfiles = i - ndirs
		
		'Sort the directories
		QuickSort names(), 0, ndirs - 1
		'Sort the files
		QuickSort names(), ndirs, ndirs + nfiles - 1

		'Add the drives
		FOR j = 0 TO 9
			IF ValidDrive(CHR$(j + 65)) = 1 THEN
				names(i) = "[" + CHR$(j + 65) + ":]"
				i = i + 1
				IF i = 540 THEN EXIT FOR
			END IF
		NEXT
		ndrives = i - nfiles - ndirs
		nnames = nfiles + ndirs + ndrives

		IF FileName$ = CHR$(0) THEN
			IF default$ = "" THEN
				FileName$ = names(0)
				IF ndirs > 0 THEN FileName$ = FileName$ + "\"
			ELSE
				FileName = default$
			END IF
		END IF

		'Here is the file selection
		sel = 0
		li = 0
		ly = 0
		selchanged = 1
		DO
			IF selchanged = 1 THEN
				s$ = GetCurPath$
				IF LEN(s$) > 29 THEN
					s$ = "..." + RIGHT$(s$, 26)
				END IF
				FontPrint s$ + STRING$(29 - LEN(s$), 32), 5, 1


				'Display the list of names
				FOR i = ly * 3 TO ly * 3 + 59
					IF i < nnames THEN
						FontPrint "  " + names(i) + STRING$(8 - LEN(names(i)), 32), ((i - ly * 3) MOD 3) * 10 + 5, ((i - ly * 3) \ 3) + 2
						IF i = sel THEN
							FontPrint CHR$(9), ((i - ly * 3) MOD 3) * 10 + 5, ((i - ly * 3) \ 3) + 2
						END IF
					ELSE
						FontPrint "          ", ((i - ly * 3) MOD 3) * 10 + 5, ((i - ly * 3) \ 3) + 2
					END IF
				NEXT
			 
				FontPrint p$ + " ", 5, 23
			 
				'Draw arrows if necessary
				IF ly > 0 THEN
					FontPrint CHR$(15), 34, 1
				ELSE
					FontPrint CHR$(32), 34, 1
				END IF
				IF nnames - ly * 3 > 60 THEN
					FontPrint CHR$(19), 34, 23
				ELSE
					FontPrint CHR$(32), 34, 23
				END IF
			   
				selchanged = 0
			END IF
		   
			k$ = FontInput$(FileName$, 19, 15, 23)
			SELECT CASE k$
				CASE CHR$(27)
					sel = -1
					EXIT DO
				CASE CHR$(0) + CHR$(72)
					IF li > 2 THEN li = li - 3
					sel = li
					IF li \ 3 < ly THEN ly = ly - 1
					IF li < ndirs THEN
						FileName$ = names(li) + "\"
					ELSE
						FileName$ = names(li)
					END IF
					selchanged = 1
				CASE CHR$(0) + CHR$(75)
					IF li > 0 THEN li = li - 1
					sel = li
					IF li \ 3 < ly THEN ly = ly - 1
					IF li < ndirs THEN
						FileName$ = names(li) + "\"
					ELSE
						FileName$ = names(li)
					END IF
					selchanged = 1
				CASE CHR$(0) + CHR$(77)
					IF li < nnames - 1 THEN li = li + 1
					sel = li
					IF li \ 3 > ly + 19 THEN ly = ly + 1
					IF li < ndirs THEN
						FileName$ = names(li) + "\"
					ELSE
						FileName$ = names(li)
					END IF
					selchanged = 1
				CASE CHR$(0) + CHR$(80)
					IF li < nnames - 3 THEN li = li + 3
					sel = li
					IF li \ 3 > ly + 19 THEN ly = ly + 1
					IF li < ndirs THEN
						FileName$ = names(li) + "\"
					ELSE
						FileName$ = names(li)
					END IF
					selchanged = 1
				CASE CHR$(0) + CHR$(71)
					li = 0
					sel = li
					ly = 0
					IF li < ndirs THEN
						FileName$ = names(li) + "\"
					ELSE
						FileName$ = names(li)
					END IF
					selchanged = 1
				CASE CHR$(0) + CHR$(79)
					li = nnames - 1
					sel = li
					ly = li \ 3 - 19
					IF ly < 0 THEN ly = 0
					IF li < ndirs THEN
						FileName$ = names(li) + "\"
					ELSE
						FileName$ = names(li)
					END IF
					selchanged = 1
				CASE CHR$(0) + CHR$(73)
					ly = ly - 19
					IF ly < 0 THEN ly = 0
					li = ly * 3
					sel = li
					IF li < ndirs THEN
						FileName$ = names(li) + "\"
					ELSE
						FileName$ = names(li)
					END IF
					selchanged = 1
				CASE CHR$(0) + CHR$(81)
					ly = ly + 19
					IF ly > nnames \ 3 - 19 THEN ly = nnames \ 3 - 19
					li = ly * 3
					IF li > nnames - 1 THEN li = nnames - 1
					sel = li
					IF li < ndirs THEN
						FileName$ = names(li) + "\"
					ELSE
						FileName$ = names(li)
					END IF
					selchanged = 1
				CASE CHR$(13)
					EXIT DO
				CASE ELSE
					IF sel <> -2 THEN
						sel = -2
						selchanged = 1
					END IF
			END SELECT
		LOOP
	 
		i = sel
		IF i = -1 THEN
			FileSelect$ = ""
			EXIT DO
		ELSE
			IF INSTR(FileName$, "\") <> 0 THEN
				CHDIR ExtractPath$(FileName$)
			ELSEIF INSTR(FileName$, ":") <> 0 THEN
				IF sel = -2 THEN
					ChDrive FileName$
				ELSE
					ChDrive MID$(names(i), 2, 1)
				END IF
			ELSE
				FileSelect$ = Fixpath$(GetCurPath$) + FileName$ + "." + extension$
				EXIT DO
			END IF
		END IF
	LOOP

	SetFontBuf OldBuf$
END FUNCTION

SUB FontBox (x, y, w, h)
	FontPrint CHR$(23) + STRING$(w - 2, 24) + CHR$(25), x, y
	FOR i = 1 TO h - 2
		FontPrint CHR$(26) + STRING$(w - 2, 32) + CHR$(27), x, y + i
	NEXT
	FontPrint CHR$(28) + STRING$(w - 2, 29) + CHR$(30), x, y + h - 1
END SUB

FUNCTION FontInput$ (text$, length, xp, yp)
	FontPrint text$ + STRING$(length - LEN(text$), 32), xp, yp
	DO
		Cursor = 0
		IF LEN(text$) < length THEN
			FontPrint "_", xp + LEN(text$), yp
		END IF
		t! = TIMER
		k$ = ""
		WHILE k$ = ""
			k$ = INKEY$
			IF TIMER - t! > .4 THEN
				IF Cursor = 1 THEN
					IF LEN(text$) < length THEN
						FontPrint "_", xp + LEN(text$), yp
					END IF
					Cursor = 0
				ELSE
					IF LEN(text$) < length THEN
						FontPrint " ", xp + LEN(text$), yp
					END IF
					Cursor = 1
				END IF
				t! = TIMER
			END IF
		WEND
		IF LEN(text$) < length THEN
			FontPrint " ", xp + LEN(text$), yp
		END IF
		SELECT CASE k$
			CASE CHR$(8)
				IF LEN(text$) > 0 THEN
					text$ = LEFT$(text$, LEN(text$) - 1)
					FontPrint " ", xp + LEN(text$), yp
				END IF
			CASE CHR$(32) TO CHR$(126)
				IF LEN(text$) < length THEN
					FontPrint k$, xp + LEN(text$), yp
					text$ = text$ + k$
				END IF
			CASE ELSE
				EXIT DO
		END SELECT
	LOOP
	FontInput$ = k$
END FUNCTION

SUB FontPrint (s AS STRING, x AS INTEGER, y AS INTEGER)
	xp = x * 8: yp = y * 8
	FOR i = 1 TO LEN(s)
		c = ASC(MID$(s, i, 1))
		IF c > 127 THEN c = 32
		DrawPic xp, yp, Font(c), -1
		MID$(FontBuf, (yp \ 8) * 40 + xp \ 8 + 1) = CHR$(c)
		xp = xp + 8
		IF xp >= 320 THEN
			xp = xp MOD 320
			yp = yp + 8
			IF yp > 200 THEN
				EXIT FOR
			END IF
		END IF
	NEXT
END SUB

FUNCTION GetTile (x, y)
	GetTile = LevelData(y * LevelW + x)
END FUNCTION

SUB GetTileColors
	FOR i = 0 TO NumTiles - 1
		bl$ = Tile(i)

		R = 0: G = 0: b = 0: h = 0
		FOR j = 0 TO 255
			p = ASC(MID$(bl$, j + 3, 1))
			IF (p AND 1) = 1 THEN b = b + 1
			IF (p AND 2) = 2 THEN G = G + 1
			IF (p AND 4) = 4 THEN R = R + 1
			IF (p AND 8) = 8 THEN h = h + 1
		NEXT
		b = (b + 128) \ 255
		G = (G + 128) \ 255
		R = (R + 128) \ 255
		h = (h + 128) \ 192
		IF h > 1 THEN h = 1
		c = b + G * 2 + R * 4 + h * 8
		TileColors(i) = c
	NEXT
END SUB

FUNCTION ListSelect (x, y, n, d)
	cp = 0
	i = d
	Cancel = 0
	DO
		k$ = ""
		t! = TIMER
		WHILE k$ = ""
			k$ = INKEY$
			IF TIMER - t! > .1 THEN
				cp = cp + 1: IF cp = 4 THEN cp = 0
				t! = TIMER
			END IF
			FontPrint CHR$(9 + cp), x, y + i
		WEND
		FontPrint CHR$(32), x, y + i
		SELECT CASE k$
			CASE CHR$(0) + CHR$(72)
				IF i = 0 THEN
					i = n - 1
				ELSE
					i = i - 1
				END IF
			CASE CHR$(0) + CHR$(80)
				IF i = n - 1 THEN
					i = 0
				ELSE
					i = i + 1
				END IF
			CASE "1", "2", "3", "4", "5", "6", "7", "8", "9", "0"
				j = ASC(k$) - 49
				IF j < n - 1 THEN
					i = j
				END IF
			CASE CHR$(13)
				EXIT DO
			CASE CHR$(27)
				Cancel = 1
				EXIT DO
		END SELECT
	LOOP
	IF Cancel = 1 THEN
		ListSelect = -1
	ELSE
		ListSelect = i
	END IF
END FUNCTION

SUB LoadFont
	DIM offset AS LONG
	OPEN OrigPath$ + "keenedit.dat" FOR BINARY AS #1
	SEEK #1, 7 * 4 + 1              'Font is the eighth entry
	GET #1, , offset
	SEEK #1, offset + 1 + 4
	FOR i = 0 TO 127
		GET #1, , Font(i)
	NEXT
	CLOSE #1
END SUB

FUNCTION LoadLevel (FileName$)
	IF Dir$(FileName$, 0) <> "" THEN
		OPEN FileName$ FOR BINARY ACCESS READ AS #1
	   
		SEEK #1, 4 + 1
		GET #1, , w
		GET #1, , h
		
	   
		REDIM LevelData(w * h) AS INTEGER
		REDIM ExtraData(w * h) AS INTEGER
	  
		'Used for adjustment for sprites
		dlen = ((w * h + 7) \ 8) * 8 + 8

		SEEK #1, 20 + 1
		j = 0
		DO
			GET #1, , b%
			IF EOF(1) THEN
				EXIT DO
			END IF
			IF b% = &HFEFE THEN
				GET #1, , n%
				GET #1, , b%
				FOR i = 0 TO n% - 1
					j = j + 1
					IF j > 8 THEN
						IF y < h THEN
							LevelData(y * w + x) = b%
							x = x + 1
							IF x = w THEN
								x = 0
								y = y + 1
								IF y = h * 2 THEN EXIT DO
							END IF
						ELSE
							IF j > dlen THEN
								ExtraData((y - h) * w + x) = b%
								x = x + 1
								IF x = w THEN
									x = 0
									y = y + 1
									IF y = h * 2 THEN EXIT DO
								END IF
							END IF
						END IF
					END IF
				NEXT
			ELSE
				j = j + 1
				IF j > 8 THEN
					IF y < h THEN
						LevelData(y * w + x) = b%
						x = x + 1
						IF x = w THEN
							x = 0
							y = y + 1
							IF y = h * 2 THEN EXIT DO
						END IF
					ELSE
						IF j > dlen THEN
							ExtraData((y - h) * w + x) = b%
							x = x + 1
							IF x = w THEN
								x = 0
								y = y + 1
								IF y = h * 2 THEN EXIT DO
							END IF
						END IF
					END IF
				END IF
			END IF
		LOOP
		CLOSE #1
		LevelW = w
		LevelH = h
		LoadLevel = 1
		Saved = 1
	ELSE
		LoadLevel = 0
	END IF
END FUNCTION

SUB loadpalette (f AS STRING)
	DIM t AS STRING * 1
	DIM loadpalfilen AS INTEGER, i AS INTEGER
	DIM R AS INTEGER, G AS INTEGER, b AS INTEGER


	loadpalfilen = FREEFILE
	OPEN f FOR BINARY AS loadpalfilen
		IF LCASE$(RIGHT$(f, 4)) = ".bmp" THEN
			SEEK #1, &H36 + 1
		ELSE
			SEEK #1, &H18 + 1
		END IF
		FOR i = 0 TO 255
			GET #loadpalfilen, , t
			b = ASC(t)
			GET #loadpalfilen, , t
			G = ASC(t)
			GET #loadpalfilen, , t
			R = ASC(t)
			GET #loadpalfilen, , t
			SetColor i, R, G, b
		NEXT
	CLOSE loadpalfilen
END SUB

SUB LoadSprites
	DIM offset AS LONG
	OPEN OrigPath$ + "keenedit.dat" FOR BINARY AS #1
	SEEK #1, (0 + TileSet) * 4 + 1'Blocks are 1,2,3th in keenedit.dat
	GET #1, , offset
	SEEK #1, offset + 1
	GET #1, , NumSprites

	DIM w AS STRING * 1, h AS STRING * 1
	FOR i = 0 TO NumSprites - 1
		GET #1, , w
		GET #1, , h
		dat$ = STRING$(ASC(w) * ASC(h), 0)
		GET #1, , dat$
		Sprite(i) = w + h + dat$
	NEXT
   
	SEEK #1, 3 * 4 + 1'Keen is 4th position
	GET #1, , offset
	SEEK #1, offset + 4 + 1

	GET #1, , w
	GET #1, , h
	dat$ = STRING$(ASC(w) * ASC(h), 0)
	GET #1, , dat$
	KeenSprite = w + h + dat$
  
	GET #1, , w
	GET #1, , h
	dat$ = STRING$(ASC(w) * ASC(h), 0)
	GET #1, , dat$
	LogoSprite = w + h + dat$
   
	CLOSE #1
END SUB

SUB LoadTiles
	DIM offset AS LONG

	OPEN OrigPath$ + "keenedit.dat" FOR BINARY AS #1
	SEEK #1, (4 + TileSet) * 4 + 1  'Blocks are 5,6,7th in keenedit.dat
	GET #1, , offset
	SEEK #1, offset + 1
	GET #1, , NumTiles

	FOR i = 0 TO NumTiles - 1
		IF i < 320 THEN
			GET #1, , Tile1(i)
		ELSE
			GET #1, , Tile2(i)
		END IF
	NEXT
	CLOSE #1
END SUB

SUB LoadTilesAndSprites
	OldBuf$ = FontBuf$
	Message "Please Wait"
	LoadTiles
	GetTileColors
	LoadSprites
	SetFontBuf OldBuf$
END SUB

SUB MainEditor
	Editing = 1

	'DrawScreen
	ShowLevel LevelX, LevelY, -1, -1, ShowGrid
	FontPrint STRING$(40, 24), 0, 20
	DO
		'Draw selected tile list
		FOR i = -7 TO 7
			IF SelTile + i >= 0 AND SelTile + i <= NumTiles - 1 THEN
				DrawTile (5 + 17 * (i + 7)), 166, SelTile + i
			ELSE
				LINE ((5 + 17 * (i + 7)), 166)-((5 + 17 * (i + 7) + 16), 166 + 16), 15, BF
			END IF
		NEXT
		LINE (4 + 17 * 7, 165)-(4 + 17 * 7 + 17, 182), 9, B

		FontPrint "Z   X   C  ", 0, 24
		DrawTile 9, 183, SelTileZ
		DrawTile 41, 183, SelTileX
		DrawTile 73, 183, SelTileC


		'Print selected tile number
		n$ = LTRIM$(RTRIM$(STR$(SelTile)))
		n$ = CHR$(15) + n$ + STRING$(3 - LEN(n$), 32)
		FontPrint n$, 16, 23

		n$ = LTRIM$(RTRIM$(STR$(LevelData((CursorY + LevelY) * LevelW + (CursorX + LevelX)))))
		n$ = CHR$(9) + n$ + STRING$(3 - LEN(n$), 32)
		FontPrint n$, 21, 23
  
		'Print Sprite under cursor
		s = ExtraData((CursorY + LevelY) * LevelW + (CursorX + LevelX))
		IF (s AND &H8000) AND MapFile = 1 THEN
			n$ = LTRIM$(RTRIM$(STR$(s AND NOT &H8000))) + "*"
			n$ = CHR$(127) + n$ + STRING$(6 - LEN(n$), 32)
		ELSE
			n$ = LTRIM$(RTRIM$(STR$(s)))
			n$ = CHR$(127) + n$ + STRING$(6 - LEN(n$), 32)
		END IF
		FontPrint n$, 26, 23

		'Print selected Sprite number
		LINE (287, 166)-(319, 191), 15, BF
		IF (SelSprite AND &H8000) AND MapFile = 1 THEN
			n$ = LTRIM$(RTRIM$(STR$(SelSprite AND NOT &H8000))) + "*"
			n$ = CHR$(17) + n$ + STRING$(6 - LEN(n$), 32)
		ELSE
			n$ = LTRIM$(RTRIM$(STR$(SelSprite)))
			n$ = CHR$(17) + n$ + STRING$(6 - LEN(n$), 32)
		END IF
		FontPrint n$, 32, 24
		'Draw selected Sprite
		IF SelSprite - 1 < NumSprites THEN
			DrawPic 287, 166, Sprite(SelSprite - 1), -1
		ELSEIF SelSprite = 255 THEN
			DrawPic 287, 166, KeenSprite, -1
		END IF

		'Print cursor position
		n$ = LTRIM$(RTRIM$(STR$(CursorX + LevelX - 2)))
		n$ = "x" + n$ + STRING$(3 - LEN(n$), 32)
		FontPrint n$, 16, 24

		n$ = LTRIM$(RTRIM$(STR$(CursorY + LevelY - 2)))
		n$ = "y" + n$ + STRING$(3 - LEN(n$), 32)
		FontPrint n$, 21, 24

		DrawCursor CursorX * 16, CursorY * 16, 1
		k$ = ""
		t! = TIMER
		WHILE k$ = ""
			k$ = INKEY$
			IF TIMER - t! >= .25 THEN
				t! = TIMER
				DrawCursor CursorX * 16, CursorY * 16, -1
			END IF
		WEND
		DrawCursor CursorX * 16, CursorY * 16, 0
		SELECT CASE k$
			CASE CHR$(0) + CHR$(72) 'Up Arrow
				IF CursorY > 0 THEN
					CursorY = CursorY - 1
				ELSE
					IF LevelY > 0 THEN
						LevelY = LevelY - 1
						Scroll 2, 16
						ShowLevel LevelX, LevelY, -1, 0, ShowGrid
					END IF
				END IF
			CASE CHR$(0) + CHR$(75) 'Left Arrow
				IF CursorX > 0 THEN
					CursorX = CursorX - 1
				ELSE
					IF LevelX > 0 THEN
						LevelX = LevelX - 1
						Scroll 3, 16
						ShowLevel LevelX, LevelY, 0, -1, ShowGrid
					END IF
				END IF
			CASE CHR$(0) + CHR$(77) 'Right Arrow
				IF CursorX < 19 THEN
					CursorX = CursorX + 1
				ELSE
					IF LevelX < (LevelW - 20) THEN
						LevelX = LevelX + 1
						Scroll 1, 16
						ShowLevel LevelX, LevelY, 19, -1, ShowGrid
					END IF
				END IF
			CASE CHR$(0) + CHR$(80) 'Down Arrow
				IF CursorY < 9 THEN
					CursorY = CursorY + 1
				ELSE
					IF LevelY < (LevelH - 10) THEN
						LevelY = LevelY + 1
						Scroll 0, 16
						ShowLevel LevelX, LevelY, -1, 9, ShowGrid
					END IF
				END IF
			CASE "+"
				IF SelTile < NumTiles - 1 THEN
					SelTile = SelTile + 1
				END IF
			CASE "-"
				IF SelTile > 0 THEN
					SelTile = SelTile - 1
				END IF
			CASE "r"
				CursorMode = 1
				StartX = CursorX + LevelX
				StartY = CursorY + LevelY
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE "l"
				CursorMode = 2
				StartX = CursorX + LevelX
				StartY = CursorY + LevelY
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(13)
				IF CursorMode = 1 THEN
					xRect StartX, StartY, (CursorX + LevelX), (CursorY + LevelY), SelTile
					CursorMode = 0: StartX = -1: StartY = -1
					ShowLevel LevelX, LevelY, -1, -1, ShowGrid
				ELSEIF CursorMode = 2 THEN
					xLine StartX, StartY, (CursorX + LevelX), (CursorY + LevelY), SelTile
					CursorMode = 0: StartX = -1: StartY = -1
					ShowLevel LevelX, LevelY, -1, -1, ShowGrid
				END IF
			CASE "f"
				xFill CursorX + LevelX, CursorY + LevelY, SelTile
				ShowSprites LevelX, LevelY
			CASE " "
				SetTile CursorX + LevelX, CursorY + LevelY, SelTile
			CASE "z"
				SetTile CursorX + LevelX, CursorY + LevelY, SelTileZ
			CASE "x"
				SetTile CursorX + LevelX, CursorY + LevelY, SelTileX
			CASE "c"
				SetTile CursorX + LevelX, CursorY + LevelY, SelTileC
			CASE "."
				SelTile = GetTile(CursorX + LevelX, CursorY + LevelY)
			CASE CHR$(26)
				SelTileZ = GetTile(CursorX + LevelX, CursorY + LevelY)
			CASE CHR$(24)
				SelTileX = GetTile(CursorX + LevelX, CursorY + LevelY)
			CASE CHR$(3)
				SelTileC = GetTile(CursorX + LevelX, CursorY + LevelY)
			CASE "t"
				SelectTile SelTile
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE "a"
				ExtraData((CursorY + LevelY) * LevelW + CursorX + LevelX) = SelSprite
				IF SelSprite = 0 THEN
					ShowLevel LevelX, LevelY, -1, -1, ShowGrid
				ELSE
					ShowSprites LevelX, LevelY
				END IF
			CASE "A", "K", "S"
				ExtraData((CursorY + LevelY) * LevelW + CursorX + LevelX) = 0
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE "k"
				ExtraData((CursorY + LevelY) * LevelW + CursorX + LevelX) = 255
				ShowSprites LevelX, LevelY
			CASE CHR$(1), CHR$(19)
				SelSprite = ExtraData((CursorY + LevelY) * LevelW + CursorX + LevelX)
			CASE "s"
				SelectSprite SelSprite
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE "m"
				IF MapFile = 0 THEN
					MapFile = 1
				ELSE
					MapFile = 0
				END IF
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE "g"
				IF ShowGrid = 0 THEN
					ShowGrid = 1
				ELSE
					ShowGrid = 0
				END IF
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(27)
				IF CursorMode = 0 THEN
					MainMenu
					ShowLevel LevelX, LevelY, -1, -1, ShowGrid
				ELSE
					CursorMode = 0: StartX = -1: StartY = -1
					ShowLevel LevelX, LevelY, -1, -1, ShowGrid
				END IF
			CASE CHR$(0) + CHR$(58 + 1)
				ShowHelp
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(0) + CHR$(58 + 2)
				t = MenuSave(LvlFile$)
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(0) + CHR$(85) 'Shift+F2
				t = MenuSave("")
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(0) + CHR$(58 + 3)
				t = MenuOpen
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(0) + CHR$(58 + 4)
				t = MenuNew
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(0) + CHR$(58 + 5)
				MenuOverview
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(0) + CHR$(58 + 6)
				MenuStatistics
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(0) + CHR$(58 + 7)
				SelectTileSet
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(0) + CHR$(58 + 8)
				t = MenuResize
				ShowLevel LevelX, LevelY, -1, -1, ShowGrid
			CASE CHR$(0) + CHR$(58 + 10)
				IF LCASE$(Prompt$("Quit (Y/N?)")) = "y" THEN
					Quit
				ELSE
					ShowLevel LevelX, LevelY, -1, -1, ShowGrid
				END IF
		END SELECT
		WHILE INKEY$ <> "": WEND    'Clear keyboard buffer
	LOOP
END SUB

SUB MainMenu
	OldBuf$ = FontBuf$
	
	DO
		LINE (0, 0)-(319, 199), 4, BF
		DrawPic 1, 0, LogoSprite, -1
		FontBox 9, 5, 21, 16
		FontPrint "  THE KEEN EDITOR", 10, 6
		FontPrint "  New Level", 10, 8
		FontPrint "  Open Level", 10, 9
		FontPrint "  Save Level", 10, 10
		FontPrint "  Save Level As", 10, 11
		FontPrint "  Resize Level", 10, 12
		FontPrint "  Level Overview", 10, 13
		FontPrint "  Level Statistics", 10, 14
		FontPrint "  Change Tileset", 10, 15
		FontPrint "  Resume Editing", 10, 16
		FontPrint "  About the Editor", 10, 17
		FontPrint "  Help", 10, 18
		FontPrint "  Quit", 10, 19
							
		i = ListSelect(10, 8, 12, 0)
		SELECT CASE i
			CASE 0  'NEW - F4
				IF MenuNew THEN EXIT DO
			CASE 1  'OPEN - F3
				IF MenuOpen THEN EXIT DO
			CASE 2  'SAVE - F2
				IF MenuSave((LvlFile$)) THEN EXIT DO
			CASE 3  'SAVE AS - Shift+F2
				IF MenuSave("") THEN EXIT DO
			CASE 4  'RESIZE - F8
				IF Editing = 1 THEN
					IF MenuResize THEN EXIT DO
				ELSE
					t$ = Prompt$("You must create or open a level!")
				END IF
			CASE 5  'OVERVIEW - F5
				IF Editing = 1 THEN
					MenuOverview
					EXIT DO
				ELSE
					t$ = Prompt$("You must create or open a level!")
				END IF
			CASE 6  'STATISTICS - F6
				IF Editing = 1 THEN
					MenuStatistics
					EXIT DO
				ELSE
					t$ = Prompt$("You must create or open a level!")
				END IF
			CASE 7  'TILE SET - F7
				SelectTileSet
			CASE 8  'RESUME EDITING
				IF Editing = 1 THEN
					EXIT DO
				ELSE
					t$ = Prompt$("You must create or open a level!")
				END IF
			CASE 9  'ABOUT THE EDITOR
				ShowAbout
			CASE 10 'HELP - F1
				ShowHelp
			CASE 11, -1  'QUIT - F10
				'If editing, ESC returns to the editor
				IF i = -1 AND Editing = 1 THEN EXIT DO
			   
				IF LCASE$(Prompt$("Quit (Y/N?)")) = "y" THEN
					Quit
				END IF
		END SELECT
	LOOP
	SetFontBuf OldBuf$
END SUB

FUNCTION MenuNew
	MenuNew = 0
	IF CheckForSave = 1 THEN
		IF SelectLevelSize(LevelW, LevelH) <> 0 THEN
			'Create the level
			CreateLevel
			SelTile = 143: SelTileZ = 143
			SelTileX = 143: SelTileC = 143
			CursorX = 2: CursorY = 2
			LevelX = 0: LevelY = 0
			LvlFile$ = ""
			MenuNew = 1
		END IF
	END IF
END FUNCTION

FUNCTION MenuOpen
	MenuOpen = 0
	IF CheckForSave = 1 THEN
		f$ = FileSelect("ck" + CHR$(TileSet + 49), "", "OPEN FILE:")
		IF f$ <> "" THEN
			IF LoadLevel(f$) = 1 THEN
				LvlFile$ = f$
				SelTile = 143: SelTileZ = 143
				SelTileX = 143: SelTileC = 143
				CursorX = 2: CursorY = 2
				LevelX = 0: LevelY = 0
				IF MID$(f$, LEN(f$) - 5, 2) = "80" THEN
					MapFile = 1
				ELSE
					MapFile = 0
				END IF
				MenuOpen = 1
			ELSE
				t$ = Prompt$("Error loading level!")
			END IF
		END IF
	END IF
END FUNCTION

SUB MenuOverview
	t$ = Prompt$("Not yet implemented.")
END SUB

FUNCTION MenuResize
	MenuResize = 0
	NewW = LevelW
	NewH = LevelH
	IF SelectLevelSize(NewW, NewH) <> 0 THEN
		'Resize the level                 
		OPEN "~tmpsave.ck~" FOR BINARY AS #1
		FOR y = 0 TO NewH - 1
			FOR x = 0 TO NewW - 1
				b = LevelData(y * LevelW + x)
				PUT #1, , b
				b = ExtraData(y * LevelW + x)
				PUT #1, , b
			NEXT
		NEXT
		REDIM LevelData(NewW * NewH)
		REDIM ExtraData(NewW * NewH)
		SEEK #1, 1
		FOR y = 0 TO NewH - 1
			FOR x = 0 TO NewW - 1
				GET #1, , b
				LevelData(y * LevelW + x) = b
				GET #1, , b
				ExtraData(y * LevelW + x) = b
			NEXT
		NEXT
		CLOSE #1
		KILL "~tmpsave.ck~"
		LevelW = NewW
		LevelH = NewH
	   
		IF LevelX > LevelW - 20 THEN LevelX = LevelW - 20
		IF LevelY > LevelH - 10 THEN LevelY = LevelH - 10
		MenuResize = 1
	END IF
END FUNCTION

FUNCTION MenuSave (f$)
	MenuSave = 0
	IF Editing = 1 THEN
		IF f$ = "" THEN f$ = FileSelect("ck" + CHR$(TileSet + 49), "", "SAVE FILE:")
		IF f$ <> "" THEN
			LvlFile$ = f$
			SaveLevel f$
			t$ = Prompt$("Level saved: " + ExtractName(f$))
			MenuSave = 1
		END IF
	ELSE
		t$ = Prompt$("You must create or open a level!")
	END IF
END FUNCTION

SUB MenuStatistics
	SELECT CASE TileSet
		CASE 0
			Statistics1
		CASE 1
			Statistics2
		CASE 2
			Statistics3
	END SELECT
END SUB

SUB Message (s AS STRING)
	xp = (40 - LEN(s) - 2) / 2
	FontBox xp, 11, LEN(s) + 2, 3
	FontPrint s, xp + 1, 12
END SUB

FUNCTION Prompt$ (s AS STRING)
	OldBuf$ = FontBuf$
	xp = (40 - LEN(s) - 3) / 2
	FontBox xp, 11, LEN(s) + 3, 3
	FontPrint s, xp + 1, 12
	  
	k$ = ""
	t! = TIMER
	WHILE k$ = ""
		k$ = INKEY$
		IF TIMER - t! > .1 THEN
			cp = cp + 1: IF cp = 4 THEN cp = 0
			t! = TIMER
		END IF
		FontPrint CHR$(9 + cp), xp + LEN(s) + 1, 12
	WEND
	Prompt = k$
	SetFontBuf OldBuf$
END FUNCTION

SUB Quit
	IF CheckForSave = 1 THEN
		'restore the original path
		ChDrive OrigPath$
		CHDIR OrigPath$
		OPEN OrigPath$ + "keenedit.dat" FOR BINARY ACCESS READ AS #1
		SEEK #1, LOF(1) - 3680 + 1
		a$ = INPUT$(3680, #1)
		CLOSE #1
		SCREEN 0: WIDTH 80
		DEF SEG = &HB800
		FOR i = 0 TO 3679
			POKE i, ASC(MID$(a$, i + 1, 1))
		NEXT
		LOCATE 24, 1
		END
	END IF
END SUB

SUB SaveLevel (FileName$)
	OPEN FileName$ FOR BINARY ACCESS WRITE AS #1
   
	dlen = ((LevelW * LevelH + 7) \ 8) * 8
	size& = dlen * 4& + 32
   
	PUT #1, , size&
	PUT #1, , LevelW
	PUT #1, , LevelH
	a$ = CHR$(2) + STRING$(5, 0)
	PUT #1, , a$
	a$ = CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0)
	PUT #1, , a$
	t = dlen * 2
	PUT #1, , t
	a$ = CHR$(&HFE) + CHR$(&HFE) + CHR$(8) + CHR$(0) + CHR$(0) + CHR$(0)
	PUT #1, , a$

	'FOR y = 0 TO LevelH - 1
	'    FOR x = 0 TO LevelW - 1
	'        b% = LevelData(y * LevelW + x)
	'        PUT #1, , b%
	'    NEXT
	'NEXT
	CompressData LevelData(), LevelW, LevelH, 1

	FOR i = 1 TO dlen - (LevelW * LevelH)
		a$ = CHR$(0) + CHR$(0)
		PUT #1, , a$
	NEXT
   
	'FOR y = 0 TO LevelH - 1
	'    FOR x = 0 TO LevelW - 1
	'        b% = ExtraData(y * LevelW + x)
	'        PUT #1, , b%
	'    NEXT
	'NEXT
	CompressData ExtraData(), LevelW, LevelH, 1

	FOR i = 1 TO dlen - (LevelW * LevelH)
		a$ = CHR$(0) + CHR$(0)
		PUT #1, , a$
	NEXT
	CLOSE #1
END SUB

SUB Scroll (d, n)
	SELECT CASE d
		CASE 0: Blit 0, 16, 0, 0, 320, 144
		CASE 1: Blit 16, 0, 0, 0, 304, 160
		CASE 2: Blit 0, 0, 0, 16, 320, 144
		CASE 3: Blit 0, 0, 16, 0, 304, 160
	END SELECT
END SUB

FUNCTION SelectLevelSize (ow, oh)
	OldBuf$ = FontBuf$
  
	Cancel = 0
	FontBox 12, 9, 15, 6
	FontPrint "  NEW LEVEL", 13, 10

	w = ow: h = oh

	'Get Width
	FontPrint "Width:  " + CHR$(21) + "   " + CHR$(17), 13, 12
	ws$ = LTRIM$(RTRIM$(STR$(LevelW)))
	DO
		k$ = FontInput(ws$, 3, 22, 12)
		SELECT CASE k$
			CASE CHR$(0) + CHR$(75)
				w = VAL(ws$)
				IF w > 20 THEN w = w - 1
				ws$ = LTRIM$(RTRIM$(STR$(w)))
			CASE CHR$(0) + CHR$(77)
				w = VAL(ws$)
				IF w < MAXWIDTH THEN w = w + 1
				ws$ = LTRIM$(RTRIM$(STR$(w)))
			CASE CHR$(13)
				w = VAL(ws$)
				EXIT DO
			CASE CHR$(27)
				w = ow
				Cancel = 1
				EXIT DO
		END SELECT
	LOOP

	IF Cancel = 0 THEN
		'Get Height
		FontPrint "Height: " + CHR$(21) + "   " + CHR$(17), 13, 13
		hs$ = LTRIM$(RTRIM$(STR$(LevelH)))
		DO
			k$ = FontInput(hs$, 3, 22, 13)
			SELECT CASE k$
				CASE CHR$(0) + CHR$(75)
					h = VAL(hs$)
					IF h > 13 THEN h = h - 1
					hs$ = LTRIM$(RTRIM$(STR$(h)))
				CASE CHR$(0) + CHR$(77)
					h = VAL(hs$)
					IF h < MAXWIDTH THEN h = h + 1
					hs$ = LTRIM$(RTRIM$(STR$(h)))
				CASE CHR$(13)
					h = VAL(hs$)
					EXIT DO
				CASE CHR$(27)
					h = oh
					Cancel = 1
					EXIT DO
			END SELECT
		LOOP
	END IF
	IF Cancel = 0 THEN
		oh = h + 4
		ow = w + 4
	END IF
	SetFontBuf OldBuf$
	IF Cancel = 1 THEN
		SelectLevelSize = 0
	ELSE
		SelectLevelSize = 1
	END IF
END FUNCTION

SUB SelectSprite (SelS1)
	OldBuf$ = FontBuf$
	FontBox 6, 5, 27, 17
	SelS = SelS1 - 1
	IF SelS > NumSprites - 1 OR SelS < 0 OR MapFile = 1 THEN
		SelRow = 3
		SelCol = 0
	ELSE
		SelRow = SelS \ 6
		SelCol = SelS MOD 6
	END IF
	DO
		FOR y = 0 TO 2
			FOR x = 0 TO 5
				i = y * 6 + x
				IF i < NumSprites THEN
					DrawPic x * 33 + 57, y * 33 + 49, Sprite(i), 255
				END IF
			NEXT
		NEXT
		IF ((SelS + 1) AND &H8000) AND MapFile = 1 THEN
			SelStr$ = LTRIM$(RTRIM$(STR$((SelS + 1) AND NOT &H8000) + "*"))
		ELSE
			SelStr$ = LTRIM$(RTRIM$(STR$((SelS + 1))))
		END IF
		FontPrint "  Custom: ", 7, 20
		FontPrint SelStr$ + STRING$(6 - LEN(SelStr$), 32), 17, 20
	  
		IF SelRow < 3 THEN
			DrawCursor SelCol * 33 + 57, SelRow * 33 + 49, 1
			k$ = ""
			t! = TIMER
			WHILE k$ = ""
				k$ = INKEY$
				IF TIMER - t! >= .25 THEN
					t! = TIMER
					DrawCursor SelCol * 33 + 57, SelRow * 33 + 49, -1
				END IF
			WEND
			DrawCursor SelCol * 33 + 57, SelRow * 33 + 49, 0
		ELSE
			FontPrint CHR$(9), 7, 20
			k$ = FontInput(SelStr$, 6, 17, 20)
			SelS = VAL(SelStr$) - 1
			IF RIGHT$(SelStr$, 1) = "*" AND MapFile = 1 THEN
				SelS = ((SelS + 1) OR &H8000) - 1
			END IF
			FontPrint CHR$(32), 7, 20
		END IF
		SELECT CASE k$
			CASE CHR$(0) + CHR$(72)
				IF SelRow > 0 THEN
					IF SelRow < 3 THEN
						SelRow = SelRow - 1
					ELSE
						SelRow = (NumSprites - 1) \ 6
						SelCol = (NumSprites - 1) MOD 6
					END IF
					SelS = SelRow * 6 + SelCol
				END IF
			CASE CHR$(0) + CHR$(75)
				IF SelCol > 0 AND SelRow < 3 THEN
					SelCol = SelCol - 1
					SelS = SelRow * 6 + SelCol
				END IF
			CASE CHR$(0) + CHR$(77)
				IF SelCol < 5 THEN
					IF SelRow * 6 + SelCol + 1 < NumSprites THEN
						SelCol = SelCol + 1
						SelS = SelRow * 6 + SelCol
					END IF
				END IF
			CASE CHR$(0) + CHR$(80)
				IF (SelRow + 1) * 6 + SelCol < NumSprites THEN
					IF SelRow < 2 THEN
						SelRow = SelRow + 1
						SelS = SelRow * 6 + SelCol
					END IF
				ELSE
					SelRow = 3: SelCol = 0
				END IF
			CASE CHR$(13)
				SelS1 = SelS + 1
				EXIT DO
			CASE CHR$(27)
				EXIT DO
		END SELECT
	LOOP
	SetFontBuf OldBuf$
END SUB

SUB SelectTile (SelT)
	OldBuf$ = FontBuf$
	FontBox 5, 0, 30, 24
	TRow = SelT \ 13 - 4
	SelRow = 4
	SelCol = SelT MOD 13
	DO WHILE TRow < 0
		TRow = TRow + 1
		SelRow = SelRow - 1
	LOOP
	DO WHILE TRow > NumTiles \ 13 - 9
		TRow = TRow - 1
		SelRow = SelRow + 1
	LOOP
	DO
		FOR y = 0 TO 8
			FOR x = 0 TO 12
				i = (TRow + y) * 13 + x
				IF i < NumTiles THEN
					DrawTile x * 17 + 49, y * 17 + 9, i
				END IF
			NEXT
		NEXT
		n$ = LTRIM$(RTRIM$(STR$((TRow + SelRow) * 13 + SelCol)))
		FontPrint CHR$(9) + n$ + STRING$(4 - LEN(n$), 32), 6, 21

		FontPrint "Z   X   C  ", 11, 22
		DrawTile 97, 168, SelTileZ
		DrawTile 129, 168, SelTileX
		DrawTile 161, 168, SelTileC

		IF TRow > 0 THEN
			FontPrint CHR$(15), 33, 21
		ELSE
			FontPrint CHR$(32), 33, 21
		END IF
		IF TRow < NumTiles \ 13 - 9 THEN
			FontPrint CHR$(19), 33, 22
		ELSE
			FontPrint CHR$(32), 33, 22
		END IF
	   
		DrawCursor SelCol * 17 + 49, SelRow * 17 + 9, 1
		k$ = ""
		t! = TIMER
		WHILE k$ = ""
			k$ = INKEY$
			IF TIMER - t! >= .25 THEN
				t! = TIMER
				DrawCursor SelCol * 17 + 49, SelRow * 17 + 9, -1
			END IF
		WEND
		DrawCursor SelCol * 17 + 49, SelRow * 17 + 9, 0
		SELECT CASE k$
			CASE CHR$(0) + CHR$(72)
				IF SelRow > 0 THEN
					SelRow = SelRow - 1
				ELSE
					IF TRow > 0 THEN
						TRow = TRow - 1
					END IF
				END IF
			CASE CHR$(0) + CHR$(75)
				IF SelCol > 0 THEN
					SelCol = SelCol - 1
				END IF
			CASE CHR$(0) + CHR$(77)
				IF SelCol < 12 THEN
					SelCol = SelCol + 1
				END IF
			CASE CHR$(0) + CHR$(80)
				IF SelRow < 8 THEN
					SelRow = SelRow + 1
				ELSE
					IF TRow < NumTiles \ 13 - 9 THEN
						TRow = TRow + 1
					END IF
				END IF
			CASE CHR$(13), CHR$(32)
				SelTile = (TRow + SelRow) * 13 + SelCol
				EXIT DO
			CASE "z", "Z"
				SelTileZ = (TRow + SelRow) * 13 + SelCol
			CASE "x", "X"
				SelTileX = (TRow + SelRow) * 13 + SelCol
			CASE "c", "C"
				SelTileC = (TRow + SelRow) * 13 + SelCol
			CASE CHR$(27)
				EXIT DO
		END SELECT
	LOOP
	SetFontBuf OldBuf$
END SUB

SUB SelectTileSet
	OldBuf$ = FontBuf$
	FontBox 8, 9, 23, 7
	FontPrint "SELECT TILE SET:", 9, 10
	FontPrint "  Marooned on Mars!", 9, 12
	FontPrint "  The Earth Explodes!", 9, 13
	FontPrint "  Keen Must Die!", 9, 14

	t = ListSelect(9, 12, 3, TileSet)
	IF t <> -1 THEN
		TileSet = t
		SelTile = 143
		SelSprite = 0
		LoadTilesAndSprites
	END IF
	SetFontBuf OldBuf$
END SUB

SUB SetColor (i AS INTEGER, R AS INTEGER, G AS INTEGER, b AS INTEGER)
	OUT &H3C8, i
	OUT &H3C9, R \ 4
	OUT &H3C9, G \ 4
	OUT &H3C9, b \ 4
END SUB

SUB SetFontBuf (NewBuf$)
	FontPrint NewBuf$, 0, 0
END SUB

SUB SetTile (x, y, t)
	LevelData(y * LevelW + x) = t
	DrawTile ((x - LevelX) * 16), ((y - LevelY) * 16), t
	IF ShowGrid THEN
		LINE ((x - LevelX) * 16, (y - LevelY) * 16)-((x - LevelX) * 16 + 15, (y - LevelY) * 16), 8
		LINE ((x - LevelX) * 16, (y - LevelY) * 16)-((x - LevelX) * 16, (y - LevelY) * 16 + 15), 8
	END IF
END SUB

SUB ShowAbout
	OldBuf$ = FontBuf$

	FontBox 0, 4, 40, 21
	NumLines = 35
	DIM FontText(NumLines) AS STRING

	   FontText(0) = "About KEEN EDITOR                   "
	   FontText(1) = "                                    "
	   FontText(2) = " KEEN EDITOR was created by Andrew  "
	   FontText(3) = " Durdin in mid-1998 when he became  "
	   FontText(4) = " interested in creating his own     "
	   FontText(5) = " levels for Commander Keen. It was  "
	   FontText(6) = " clumsy, buggy, and lacked many     "
	   FontText(7) = " features, but it did the job for   "
	   FontText(8) = " him. In late 2000 he discovered    "
	   FontText(9) = " the online Keen fan community,     "
	  FontText(10) = " and decided to share his editor    "
	  FontText(11) = " with it. At that point, he (and    "
	  FontText(12) = " others who tried it) discovered    "
	  FontText(13) = " many problems still in the pro-    "
	  FontText(14) = " gram, not least of which was the   "
	  FontText(15) = " lack of support for Keens 2 & 3.   "
	  FontText(16) = " So in December 2000, he rewrote    "
	  FontText(17) = " almost all of it, improving the    "
	  FontText(18) = " user interface and adding feat-    "
	  FontText(19) = " ures and removing bugs.            "
	  FontText(20) = " KEEN EDITOR is now a fully feat-   "
	  FontText(21) = " ured editor for episodes 1 to 3,   "
	  FontText(22) = " and is dedicated to Commander      "
	  FontText(23) = " Keen fans everywhere.              "
	  FontText(24) = "                                    "
	  FontText(25) = " KEEN EDITOR is copyright (C)2000   "
	  FontText(26) = " by Andrew Durdin. Source code is   "
	  FontText(27) = " available on request (though em-   "
	  FontText(28) = " barrassing in places :).           "
	  FontText(29) = "                                    "
	  FontText(30) = " Andrew Durdin may be contacted by  "
	  FontText(31) = " email at andy@durdin.net, or you   "
	  FontText(32) = " can visit his website at           "
	  FontText(33) = " http://durdin.net/andy/            "
	  FontText(34) = "                                    "
	  FontText(35) = " Have fun with KEEN EDITOR!         "
			 
	TextY = 0
	DO
		FOR i = 0 TO 18
			FontPrint FontText(TextY + i), 1, 5 + i
		NEXT
		IF TextY > 0 THEN
			FontPrint CHR$(15), 38, 5
		ELSE
			FontPrint CHR$(32), 38, 5
		END IF
		IF TextY < NumLines - 18 THEN
			FontPrint CHR$(19), 38, 23
		ELSE
			FontPrint CHR$(32), 38, 23
		END IF
	  
		k$ = ""
		WHILE k$ = ""
			k$ = INKEY$
		WEND
		SELECT CASE k$
			CASE CHR$(0) + CHR$(72)
				IF TextY > 0 THEN TextY = TextY - 1
			CASE CHR$(0) + CHR$(73)
				IF TextY > 17 THEN
					TextY = TextY - 18
				ELSE
					TextY = 0
				END IF
			CASE CHR$(0) + CHR$(80)
				IF TextY < NumLines - 18 THEN TextY = TextY + 1
			CASE CHR$(0) + CHR$(81)
				IF TextY < NumLines - 18 - 17 THEN
					TextY = TextY + 18
				ELSE
					TextY = NumLines - 18
				END IF
			CASE CHR$(27), CHR$(13)
				EXIT DO
		END SELECT
	LOOP

	SetFontBuf OldBuf$
END SUB

SUB ShowHelp
	OldBuf$ = FontBuf$
   
	FontBox 0, 4, 40, 21
	NumLines = 139
	DIM FontText(NumLines) AS STRING

	  FontText(0) = "KEEN EDITOR - Help                  "
	  FontText(1) = "                                    "
	  FontText(2) = "Welcome to KEEN EDITOR, the premier "
	  FontText(3) = "DOS-based graphical level editor for"
	  FontText(4) = "Commander Keen episodes 1 to 3.     "
	  FontText(5) = "To navigate the menus in KEEN EDITOR"
	  FontText(6) = "use the arrows (,) and ENTER to   "
	  FontText(7) = "select an option, and ESC to cancel "
	  FontText(8) = "a selection.                        "
	  FontText(9) = "                                    "
	 FontText(10) = "The options in the main menu are    "
	 FontText(11) = "explained below. Most of these have "
	 FontText(12) = "shortcut keys so they can be chosen "
	 FontText(13) = "while editing a file, for faster and"
	 FontText(14) = "easier access. The shortcut keys are"
	 FontText(15) = "listed in parentheses following the "
	 FontText(16) = "option name.                        "
	 FontText(17) = "                                    "
	 FontText(18) = "NEW LEVEL (F4): Makes a new level.  "
	 FontText(19) = "  You can specify a level size up to"
	 FontText(20) = "  170x170 tiles, although if the    "
	 FontText(21) = "  product of the level width and    "
	 FontText(22) = "  height is greater than 25000, the "
	 FontText(23) = "  editor (and Commander Keen) may   "
	 FontText(24) = "  behave erratically.               "
	 FontText(25) = "                                    "
	 FontText(26) = "OPEN LEVEL (F3): Loads an existing  "
	 FontText(27) = "  level from a file. The file selec-"
	 FontText(28) = "  tor shows only files created with "
	 FontText(29) = "  the currently selected tile set   "
	 FontText(30) = "  (see TILESET below).              "
	 FontText(31) = "                                    "
	 FontText(32) = "SAVE LEVEL (F2): Saves the level    "
	 FontText(33) = "  being edited. The proper extension"
	 FontText(34) = "  (CK1, CK2, or CK3) is added auto- "
	 FontText(35) = "  matically according to the sel-   "
	 FontText(36) = "  ected tile set.                   "
	 FontText(37) = "                                    "
	 FontText(38) = "SAVE LEVEL AS (Shift+F2): Saves the "
	 FontText(39) = "  level under a new name.           "
	 FontText(40) = "                                    "
	 FontText(41) = "LEVEL OVERVIEW (F5): Shows a small  "
	 FontText(42) = "  overview of the whole level, so   "
	 FontText(43) = "  you can see the general layout of "
	 FontText(44) = "  the level. Sprites are not shown. "
	 FontText(45) = "                                    "
	 FontText(46) = "LEVEL STATISTICS (F6): Shows amount "
	 FontText(47) = "  of treasures and the total points "
	 FontText(48) = "  in the level, and the number of   "
	 FontText(49) = "  rayguns and enemies in the level. "
	 FontText(50) = "                                    "
	 FontText(51) = "CHANGE TILESET (F7): Selects the    "
	 FontText(52) = "  tilesets for Commander Keen epi-  "
	 FontText(53) = "  sodes 1, 2, and 3. The levels in  "
	 FontText(54) = "  each episode may only be edited   "
	 FontText(55) = "  when the correct tileset is cho-  "
	 FontText(56) = "  sen.                              "
	 FontText(57) = "                                    "
	 FontText(58) = "RESUME EDITING: Returns to the main "
	 FontText(59) = "  level editor from the menu.       "
	 FontText(60) = "                                    "
	 FontText(61) = "ABOUT THE EDITOR: Displays credits, "
	 FontText(62) = "  copyright, and contact information"
	 FontText(63) = "  for KEEN EDITOR.                  "
	 FontText(64) = "                                    "
	 FontText(65) = "HELP (F1): Displays basic informa-  "
	 FontText(66) = "  tion on using the editor.         "
	 FontText(67) = "                                    "
	 FontText(68) = "QUIT (F10): Returns to DOS.         "
	 FontText(69) = "                                    "
	 FontText(70) = "Apart from these shortcut keys,     "
	 FontText(71) = "there are several other keys that   "
	 FontText(72) = "are used to control the editor:     "
	 FontText(73) = "                                    "
	 FontText(74) = "Arrows (" + CHR$(21) + "): Move the cursor (	). "
	 FontText(75) = "                                    "
	 FontText(76) = "Space: Sets the tile under the cur- "
	 FontText(77) = "  sor to the main selected tile.    "
	 FontText(78) = "                                    "
	 FontText(79) = "Z, X, C: Set the tile under the cur-"
	 FontText(80) = "  sor to the respective tile.       "
	 FontText(81) = "                                    "
	 FontText(82) = "Period (.): Picks up the tile under "
	 FontText(83) = "  the cursor as the main selected   "
	 FontText(84) = "  tile.                             "
	 FontText(85) = "                                    "
	 FontText(86) = "Ctrl+Z, Ctrl+X, Ctrl+C: Pick up the "
	 FontText(87) = "  tile under the cursor as the res- "
	 FontText(88) = "  pective tile.                     "
	 FontText(89) = "                                    "
	 FontText(90) = "Plus, Minus (+,-): Change the main  "
	 FontText(91) = "  selected tile.                    "
	 FontText(92) = "                                    "
	 FontText(93) = "T: Allows you to choose the selected"
	 FontText(94) = "  tiles from a large grid. Use the  "
	 FontText(95) = "  Z, X, C, and Space keys to choose "
	 FontText(96) = "  the appropriate tile.             "
	 FontText(97) = "                                    "
	 FontText(98) = "A: Places the currently selected    "
	 FontText(99) = "  sprite at the cursor position.    "
	FontText(100) = "                                    "
	FontText(101) = "Shift+A: Erases the sprite from un- "
	FontText(102) = "  der the cursor.                   "
	FontText(103) = "                                    "
	FontText(104) = "Ctrl+A: Picks up the sprite under   "
	FontText(105) = "  the cursor as the selected sprite."
	FontText(106) = "                                    "
	FontText(107) = "S: Allows you to choose the selected"
	FontText(108) = "  sprite from a large grid, or enter"
	FontText(109) = "  a sprite number (for editing the  "
	FontText(110) = "  map levels)                       "
	FontText(111) = "                                    "
	FontText(112) = "K: Places Commander Keen at the cur-"
	FontText(113) = "  sor position. Use Shift+A to erase"
	FontText(114) = "  him if necessary.                 "
	FontText(115) = "                                    "
	FontText(116) = "F: Flood-fills area under the cursor"
	FontText(117) = "  with the main selected tile.      "
	FontText(118) = "                                    "
	FontText(119) = "L: Marks the start of a line. Use   "
	FontText(120) = "  the Enter key to mark the end of  "
	FontText(121) = "  the line and draw it with the main"
	FontText(122) = "  selected tile.                    "
	FontText(123) = "                                    "
	FontText(124) = "R: Marks one corner of a solid rect-"
	FontText(125) = "  angle. Use the Enter key to mark  "
	FontText(126) = "  the opposite corner and draw it   "
	FontText(127) = "  with the main selected tile.      "
	FontText(128) = "                                    "
	FontText(129) = "G: Toggles a grid on and off.       "
	FontText(130) = "                                    "
	FontText(131) = "M: Toggles interpretation of the    "
	FontText(132) = "  current file as a 'Map level'.    "
	FontText(133) = "  This will be set by default for   "
	FontText(134) = "  files called Level80.             "
	FontText(135) = "                                    "
	FontText(136) = "ESC: Brings up the main menu.       "
	FontText(137) = "                                    "
	FontText(138) = "That's it! Have fun using the level "
	FontText(139) = "editor! Press ESC to return.        "
			  
	TextY = 0
	DO
		FOR i = 0 TO 18
			FontPrint FontText(TextY + i), 1, 5 + i
		NEXT
		IF TextY > 0 THEN
			FontPrint CHR$(15), 38, 5
		ELSE
			FontPrint CHR$(32), 38, 5
		END IF
		IF TextY < NumLines - 18 THEN
			FontPrint CHR$(19), 38, 23
		ELSE
			FontPrint CHR$(32), 38, 23
		END IF
	   
		k$ = ""
		WHILE k$ = ""
			k$ = INKEY$
		WEND
		SELECT CASE k$
			CASE CHR$(0) + CHR$(72)
				IF TextY > 0 THEN TextY = TextY - 1
			CASE CHR$(0) + CHR$(73)
				IF TextY > 17 THEN
					TextY = TextY - 18
				ELSE
					TextY = 0
				END IF
			CASE CHR$(0) + CHR$(80)
				IF TextY < NumLines - 18 THEN TextY = TextY + 1
			CASE CHR$(0) + CHR$(81)
				IF TextY < NumLines - 18 - 17 THEN
					TextY = TextY + 18
				ELSE
					TextY = NumLines - 18
				END IF
			CASE CHR$(27), CHR$(13)
				EXIT DO
		END SELECT
	LOOP
	SetFontBuf OldBuf$
END SUB

SUB ShowLevel (xp, yp, nc, nr, grid)
	IF nc = -1 THEN
		sx = xp
		ex = xp + 19
	ELSE
		sx = xp + nc
		ex = xp + nc
	END IF
	IF nr = -1 THEN
		sy = yp
		ey = yp + 9
	ELSE
		sy = yp + nr
		ey = yp + nr
	END IF
	FOR y = sy TO ey
		FOR x = sx TO ex
			IF x < LevelW AND y < LevelH THEN
				b = LevelData(y * LevelW + x)
				DrawTile ((x - xp) * 16), ((y - yp) * 16), b
			END IF
		NEXT
	NEXT
	ShowSprites xp, yp
	IF StartX >= LevelX AND StartX < LevelX + 20 AND StartY >= LevelY AND StartY < LevelY + 10 THEN
		CALL DrawPic((StartX - LevelX) * 16 + 4, (StartY - LevelY) * 16 + 4, Font(9), 1)
	END IF
	IF grid <> 0 THEN
		FOR y = sy TO ey
			LINE (0, (y - yp) * 16)-(319, (y - yp) * 16), 8
		NEXT
		FOR x = sx TO ex
			LINE ((x - xp) * 16, 0)-((x - xp) * 16, 159), 8
		NEXT
	END IF
END SUB

SUB ShowSprites (xp, yp)
	FOR y = yp TO yp + 9
		FOR x = xp TO xp + 19
			IF x < LevelW AND y < LevelH THEN
				b = ExtraData(y * LevelW + x)
				IF MapFile THEN
					IF b <> 0 THEN
						'IF (b AND &H8000) THEN
						'    b = b AND NOT &H8000
						'    n$ = LTRIM$(RTRIM$(CHR$(b + 64)))
						'    FontPrint n$, (x - xp) * 2, (y - yp) * 2
						'ELSE
						'    n$ = LTRIM$(RTRIM$(CHR$(b + 96)))
						'    FontPrint n$, (x - xp) * 2, (y - yp) * 2
						'END IF
						LINE ((x - xp) * 16, (y - yp) * 16)-((x - xp) * 16 + 15, (y - yp) * 16 + 15), 14, B
					END IF
				ELSE
					SELECT CASE b
						CASE 0
							'Nothing
						CASE 255'keen
							IF (y - yp) = 9 THEN
								DrawTruncPic ((x - xp) * 16), ((y - yp) * 16), KeenSprite, 255, 16
							ELSE
								DrawPic ((x - xp) * 16), ((y - yp) * 16), KeenSprite, 255
							END IF
						CASE 1 TO NumSprites
							'We also need special handling for the leg and
							'arm sprites in #3
							IF (y - yp) = 9 THEN
								DrawTruncPic ((x - xp) * 16), ((y - yp) * 16), Sprite(b - 1), 255, 16
							ELSE
								DrawPic ((x - xp) * 16), ((y - yp) * 16), Sprite(b - 1), 255
							END IF
						CASE ELSE
							n$ = LTRIM$(RTRIM$(STR$(b)))
							FontPrint n$, (x - xp) * 2, (y - yp) * 2
					END SELECT
				END IF
			END IF
		NEXT
	NEXT
END SUB

SUB Statistics1
	pizza = 0: lolly = 0: cola = 0: book = 0: teddy = 0
	raygun = 0: pogo = 0: joystick = 0: battery = 0: vacuum = 0: whisky = 0
	yorp = 0: garg = 0: vort = 0: pusher = 0: zzap = 0: ice = 0: rope = 0

	FOR y = 0 TO LevelH - 1
		FOR x = 0 TO LevelW - 1
			SELECT CASE GetTile(x, y)
				CASE 201: pizza = pizza + 1
				CASE 202: lolly = lolly + 1
				CASE 203: cola = cola + 1
				CASE 204: book = book + 1
				CASE 205: teddy = teddy + 1
				CASE 175: raygun = raygun + 1
				CASE 176: pogo = 1
				CASE 221 TO 224: joystick = 1
				CASE 237 TO 240: battery = 1
				CASE 241 TO 244: vacuum = 1
				CASE 245 TO 248: whisky = 1
			END SELECT
			SELECT CASE ExtraData(y * LevelW + x)
				CASE 1: yorp = yorp + 1
				CASE 2: garg = garg + 1
				CASE 3: vort = vort + 1
				CASE 4: pusher = pusher + 1
				CASE 5: zzap = zzap + 1
				CASE 6 TO 9: ice = ice + 1
				CASE 10: rope = rope + 1
			END SELECT
		NEXT
	NEXT
	ClearScreen
	DrawTile 8, 4, 202
	FontPrint LTRIM$(RTRIM$(STR$(lolly))), 4, 1
	DrawTile 8, 28, 203
	FontPrint LTRIM$(RTRIM$(STR$(cola))), 4, 4
	DrawTile 8, 52, 201
	FontPrint LTRIM$(RTRIM$(STR$(pizza))), 4, 7
	DrawTile 8, 76, 204
	FontPrint LTRIM$(RTRIM$(STR$(book))), 4, 10
	DrawTile 8, 100, 205
	FontPrint LTRIM$(RTRIM$(STR$(teddy))), 4, 13
			 
	FontPrint "Total Score: " + LTRIM$(RTRIM$(STR$(lolly * 100& + cola * 200& + pizza * 500& + book * 1000& + teddy * 5000&))), 2, 18
			  
	DrawTile 72, 4, 175
	FontPrint LTRIM$(RTRIM$(STR$(raygun))), 12, 1

	IF pogo <> 0 THEN DrawTile 72, 28, 176
	IF joystick <> 0 THEN DrawTile 72, 52, 222
	IF battery <> 0 THEN DrawTile 96, 52, 238
	IF vacuum <> 0 THEN DrawTile 72, 76, 242
	IF whisky <> 0 THEN DrawTile 96, 76, 246

	DrawPic 140, 4, Sprite(0), 255
	FontPrint LTRIM$(RTRIM$(STR$(yorp))), 21, 3
	DrawPic 136, 44, Sprite(1), 255
	FontPrint LTRIM$(RTRIM$(STR$(garg))), 21, 7
	DrawPic 136, 84, Sprite(2), 255
	FontPrint LTRIM$(RTRIM$(STR$(vort))), 21, 12
	DrawPic 200, 12, Sprite(3), 255
	FontPrint LTRIM$(RTRIM$(STR$(pusher))), 28, 2
	DrawPic 200, 28, Sprite(4), 255
	FontPrint LTRIM$(RTRIM$(STR$(zzap))), 28, 5
	DrawPic 200, 68, Sprite(5), 255
	FontPrint LTRIM$(RTRIM$(STR$(ice))), 28, 9
	DrawPic 200, 92, Sprite(9), 255
	FontPrint LTRIM$(RTRIM$(STR$(rope))), 28, 12

	WHILE INKEY$ = "": WEND
END SUB

SUB Statistics2
	lolly = 0: cola = 0: burger = 0: cake = 0: teddy = 0
	raygun = 0: pogo = 0
	vort = 0: kid = 0: elite = 0: pusher = 0: zzap = 0: platform = 0: amoeba = 0

	FOR y = 0 TO LevelH - 1
		FOR x = 0 TO LevelW - 1
			SELECT CASE GetTile(x, y)
				CASE 201, 306: burger = burger + 1
				CASE 202: lolly = lolly + 1
				CASE 203: cola = cola + 1
				CASE 204: cake = cake + 1
				CASE 205: teddy = teddy + 1
				CASE 175: raygun = raygun + 1
				CASE 176: pogo = 1
			END SELECT
			SELECT CASE ExtraData(y * LevelW + x)
				CASE 1: vort = vort + 1
				CASE 2: kid = kid + 1
				CASE 3: elite = elite + 1
				CASE 4: pusher = pusher + 1
				CASE 5: zzap = zzap + 1
				CASE 6: platform = platform + 1
				CASE 7: amoeba = amoeba + 1
			END SELECT
		NEXT
	NEXT
	ClearScreen
	DrawTile 8, 4, 202
	FontPrint LTRIM$(RTRIM$(STR$(lolly))), 4, 1
	DrawTile 8, 28, 203
	FontPrint LTRIM$(RTRIM$(STR$(cola))), 4, 4
	DrawTile 8, 52, 201
	FontPrint LTRIM$(RTRIM$(STR$(burger))), 4, 7
	DrawTile 8, 76, 204
	FontPrint LTRIM$(RTRIM$(STR$(cake))), 4, 10
	DrawTile 8, 100, 205
	FontPrint LTRIM$(RTRIM$(STR$(teddy))), 4, 13
			
	FontPrint "Total Score: " + LTRIM$(RTRIM$(STR$(lolly * 100& + cola * 200& + burger * 500& + cake * 1000& + teddy * 5000&))), 2, 18
			 
	DrawTile 72, 4, 175
	FontPrint LTRIM$(RTRIM$(STR$(raygun))), 12, 1

	IF pogo <> 0 THEN DrawTile 72, 28, 176

	DrawPic 136, 4, Sprite(0), 255
	FontPrint LTRIM$(RTRIM$(STR$(vort))), 21, 3
	DrawPic 144, 36, Sprite(1), 255
	FontPrint LTRIM$(RTRIM$(STR$(kid))), 21, 7
	DrawPic 136, 84, Sprite(2), 255
	FontPrint LTRIM$(RTRIM$(STR$(elite))), 21, 12
	DrawPic 200, 12, Sprite(3), 255
	FontPrint LTRIM$(RTRIM$(STR$(pusher))), 28, 2
	DrawPic 200, 28, Sprite(4), 255
	FontPrint LTRIM$(RTRIM$(STR$(zzap))), 28, 5
	DrawPic 188, 68, Sprite(5), 255
	FontPrint LTRIM$(RTRIM$(STR$(platform))), 28, 9
	DrawPic 200, 92, Sprite(6), 255
	FontPrint LTRIM$(RTRIM$(STR$(amoeba))), 28, 12

	WHILE INKEY$ = "": WEND
END SUB

SUB Statistics3
	lolly = 0: cola = 0: burger = 0: cake = 0: teddy = 0
	ankh = 0: raygun = 0: bullet = 0
	vort = 0: kid = 0: mom = 0: foob = 0: ninja = 0: meep = 0: ball = 0
	jack = 0: plath = 0: platv = 0: amoeba = 0: heart = 0: shoth = 0: shotv = 0: arm = 0
	legl = 0: legr = 0
	FOR y = 0 TO LevelH - 1
		FOR x = 0 TO LevelW - 1
			SELECT CASE GetTile(x, y)
				CASE 144, 157, 170, 183, 196, 209: lolly = lolly + 1
				CASE 145, 158, 171, 184, 197, 210: burger = burger + 1
				CASE 146, 159, 172, 185, 198, 211: cola = cola + 1
				CASE 147, 160, 173, 186, 199, 212: cake = cake + 1
				CASE 148, 161, 174, 187, 200, 213: teddy = teddy + 1
				CASE 149, 162, 175, 188, 201, 214: ankh = ankh + 1
				CASE 150, 163, 176, 189, 202, 215: bullet = bullet + 1
				CASE 151, 164, 177, 190, 203, 216: raygun = raygun + 1
			END SELECT
			SELECT CASE ExtraData(y * LevelW + x)
				CASE 1, 11: vort = vort + 1
				CASE 2: kid = kid + 1
				CASE 3: mom = mom + 1
				CASE 4: foob = foob + 1
				CASE 5: ninja = ninja + 1
				CASE 6: meep = meep + 1
				CASE 12: amoeba = amoeba + 1
				CASE 13: heart = heart + 1
			END SELECT
		NEXT
	NEXT
	ClearScreen
	DrawTile 8, 4, 209
	FontPrint LTRIM$(RTRIM$(STR$(lolly))), 4, 1
	DrawTile 8, 28, 211
	FontPrint LTRIM$(RTRIM$(STR$(cola))), 4, 4
	DrawTile 8, 52, 210
	FontPrint LTRIM$(RTRIM$(STR$(burger))), 4, 7
	DrawTile 8, 76, 212
	FontPrint LTRIM$(RTRIM$(STR$(cake))), 4, 10
	DrawTile 8, 100, 213
	FontPrint LTRIM$(RTRIM$(STR$(teddy))), 4, 13
		   
	FontPrint "Total Score: " + LTRIM$(RTRIM$(STR$(lolly * 500& + cola * 200& + burger * 100& + cake * 1000& + teddy * 5000&))), 2, 18
			
	DrawTile 72, 4, 214
	FontPrint LTRIM$(RTRIM$(STR$(ankh))), 12, 1
   
	DrawTile 72, 28, 216
	FontPrint LTRIM$(RTRIM$(STR$(raygun))), 12, 4
   
	DrawTile 72, 52, 215
	FontPrint LTRIM$(RTRIM$(STR$(bullet))), 12, 7

	DrawPic 136, 4, Sprite(0), 255
	FontPrint LTRIM$(RTRIM$(STR$(vort))), 21, 2
	DrawPic 144, 28, Sprite(1), 255
	FontPrint LTRIM$(RTRIM$(STR$(kid))), 21, 6
	DrawPic 136, 60, Sprite(2), 255
	FontPrint LTRIM$(RTRIM$(STR$(mom))), 21, 9
	DrawPic 144, 92, Sprite(3), 255
	FontPrint LTRIM$(RTRIM$(STR$(foob))), 21, 13

	DrawPic 200, 4, Sprite(4), 255
	FontPrint LTRIM$(RTRIM$(STR$(ninja))), 28, 2
	DrawPic 200, 44, Sprite(5), 255
	FontPrint LTRIM$(RTRIM$(STR$(meep))), 28, 6
	DrawPic 200, 68, Sprite(11), 255
	FontPrint LTRIM$(RTRIM$(STR$(amoeba))), 28, 9
	DrawPic 200, 92, Sprite(12), 255
	FontPrint LTRIM$(RTRIM$(STR$(heart))), 28, 12
	
	WHILE INKEY$ = "": WEND
END SUB

FUNCTION Tile$ (i AS INTEGER)
	IF i < 320 THEN
		Tile$ = Tile1$(i)
	ELSE
		Tile$ = Tile2$(i)
	END IF
END FUNCTION

SUB xFill (x, y, t)
	FillTile = GetTile(x, y)
	IF FillTile = t THEN EXIT SUB
	xFillLine (x), (y), (t)
END SUB

SUB xFillLine (x, y, t)
   
	'Find left extent of blank color on this line
	lx = x
	DO UNTIL GetTile(lx, y) <> FillTile
		lx = lx - 1
		IF lx = -1 THEN EXIT DO
	LOOP
	lx = lx + 1

	'Find right extent of blank color on this line
	rx = x
	DO UNTIL GetTile(rx, y) <> FillTile
		rx = rx + 1
		IF rx = LevelW THEN EXIT DO
	LOOP
	rx = rx - 1

	'Fill this line
	FOR i = lx TO rx
		SetTile i, y, t
	NEXT

	'Fill up
	IF y > 0 THEN
		FOR i = lx TO rx
			IF GetTile(i, y - 1) = FillTile THEN
				xFillLine i, y - 1, t
			END IF
		NEXT
	END IF

	'Fill down
	IF y < LevelH - 1 THEN
		FOR i = lx TO rx
			IF GetTile(i, y + 1) = FillTile THEN
				xFillLine i, y + 1, t
			END IF
		NEXT
	END IF
END SUB

SUB xLine (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, t AS INTEGER)
	'Uses Bresenham's algorithm For drawing a line
	DIM LgDelta, ShDelta, LgStep, ShStep, Cycle, pointaddr
   
	SetTile x2, y2, t
 
	LgDelta = x2 - x1
	ShDelta = y2 - y1
	IF LgDelta < 0 THEN
		LgDelta = -LgDelta
		LgStep = -1
	ELSE
		LgStep = 1
	END IF
	IF ShDelta < 0 THEN
		ShDelta = -ShDelta
		ShStep = -1
	ELSE
		ShStep = 1
	END IF
	IF LgDelta > ShDelta THEN
		Cycle = LgDelta \ 2
		DO WHILE x1 <> x2
			SetTile x1, y1, t
			x1 = x1 + LgStep
			Cycle = Cycle + ShDelta
			IF Cycle > LgDelta THEN
				y1 = y1 + ShStep
				Cycle = Cycle - LgDelta
			END IF
		LOOP
	ELSE
		Cycle = ShDelta \ 2
		SWAP LgDelta, ShDelta
		SWAP LgStep, ShStep
		DO WHILE y1 <> y2
			SetTile x1, y1, t
			y1 = y1 + LgStep
			Cycle = Cycle + ShDelta
			IF Cycle > LgDelta THEN
				x1 = x1 + ShStep
				Cycle = Cycle - LgDelta
			END IF
		LOOP
	END IF
END SUB

SUB xRect (x1, y1, x2, y2, t)
	yd = SGN(y2 - y1): IF yd = 0 THEN yd = 1
	xd = SGN(x2 - x1): IF xd = 0 THEN xd = 1
	FOR j = y1 TO y2 STEP yd
		FOR i = x1 TO x2 STEP xd
			SetTile i, j, t
		NEXT
	NEXT
END SUB

